<?php

if ( ! defined( 'MYCRED_buddyboss_SLUG' ) ) exit;

    class myCRED_buddy_blockusers_Settings extends myCRED_Module {

    	protected static $_instance = NULL;
		protected $settings;
		public $core_point_types;
        
        public static function instance() {
			if ( is_null( self::$_instance ) ) {
				self::$_instance = new self();
			}
			return self::$_instance;
		}

        public function __construct($type = MYCRED_DEFAULT_TYPE_KEY) {

        	global $activities_template;

            parent::__construct('myCred_BP_BLOCKUSERS', array(
				'module_name' => 'general',
	
			), $type ); 

			$buddypress_settings = mycred_get_addon_settings( 'buddypress' );

			if(empty($buddypress_settings)) {
				return;
			}

            add_action( 'mycred_bp_before_settings', array( $this, 'mycred_buddyboss_user_settings' ), 10, 1 );
            add_action( 'bp_set_member_type', array($this,'mycred_bp_set_member_type'), 10, 3 );
            add_action( 'admin_enqueue_scripts', array($this,'load_buddyboss_dependency_scripts'),1000 );
            add_filter('mycred_bp_sanitize_settings', array($this,'sanitize_extra_settings'),10,3);	
            add_filter( 'bp_activity_allowed_tags', array($this,'mycred_bp_activity_allowed_tags') );
            add_action( 'bp_activity_entry_content', array($this,'mycred_bp_activity_empty_content'), 10 );
            add_filter( 'bp_get_activity_content_body', array($this,'mycred_bp_activity_content'),999,2 );  
            add_action( 'bbp_theme_after_reply_author_details', array($this,'mycred_bbp_reply_author_details') );
            add_action( 'wp_enqueue_scripts', array($this,'buddyboss_front_scripts') );

            if( ($buddypress_settings['balance_location'] == 'top' || $buddypress_settings['balance_location'] == 'both' )) {
             add_action( 'mycred_buddypress_profile_header', array($this,'mycred_buddypress_profile_header') );
            }
            add_filter( 'bp_get_member_avatar', array($this,'mycred_buddypress_get_member_avatar') );
           
            if ( $buddypress_settings['balance_location'] == 'profile_tab' || $buddypress_settings['balance_location'] == 'both' ) {
            	add_action('mycred_buddypress_profile_details',array($this,'mycred_buddypress_profile_details'));
            }

            
        }

        public function get_mycred_main_page_url( $urls ) {
		
			$args = array(
				'page'         => MYCRED_MAIN_SLUG ,
				
			);

			return esc_url( add_query_arg( $args, admin_url( 'admin.php' ) ) );

		}

        

        public function mycred_buddypress_profile_details() {
        	global $mycred_types;
        	$output       = '';
			$user_id      = bp_displayed_user_id();
			$settings = mycred_get_addon_defaults( 'badges' );
			$mycred_types = mycred_get_types();
			$users_rank = mycred_get_users_rank( $user_id );

        	if( class_exists( 'myCRED_Badge' ) ) {
				$badges = mycred_get_badge_ids();
			}

			if( class_exists( 'myCRED_Ranks_Module' ) ){
				$ranks = mycred_get_ranks();
			}

			$ids_title = array();
			$badges_data = array();

			?>

			<?php




			$buddyboss_profile_points = mycred_get_option( 'buddyboss_profile_points', true );

			if(!empty($buddyboss_profile_points)) : ?>
			<?php if(is_array($buddyboss_profile_points) || is_object($buddyboss_profile_points)) : ?>

				 <?php foreach( $buddyboss_profile_points as $type => $label ) : ?>

        		 	  	<?php 

        		 	  	$mycred   = mycred( $type );

        		 	  	if ( $mycred->exclude_user( $user_id ) ) continue;

        		 	  	$balance  = $mycred->get_users_balance( $user_id, $type );

						$settings = mycred_get_addon_settings( 'buddypress' );


        		 	  	if($buddyboss_profile_points[$type] == true) : ?>

        		 	<div class="mycred-bbpress-user-profile-details-points-type">

        		 	  	<h4><?php echo esc_html_e( $mycred->plural(), 'mycred' );  ?></h4>


        		 	    <table class="buddyboss-profile-items">
        		 	  		<tr class="buddyboss-profile-row">
							    <td class="buddyboss-points-label"><?php echo  esc_html_e( 'Current Balance', 'mycred_buddyboss' ) ?></td>
							    <td class="data"> <?php echo esc_html_e( $mycred->format_creds( $balance ), 'mycred_buddyboss' ); ?></td>
    
  							</tr>
	        		 	 

	                     </table>

                    </div>


			 <?php endif; 
			       endforeach; 
			       endif;
			       endif;

			     ?>

			<div class="user-badges">


			      <div class="mycred-badges-display">

					<h4>Badges</h4>

				</div>


            <?php foreach ($badges as $key => $value)  : ?>

                <?php

					$badges_data[$key]['id'] = $value;
                	$badges_data[$key]['title'] = get_the_title($value);

				?>

				   <div class="mycred-bbpress-profile-user-badges-type">

        		 	  	 <span class="mycred-bbpress-profile-badges-label mycred-bbpress-profile-badges-label">
                            <?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?>
                         </span>

                         	<a href="<?php echo esc_url(get_permalink( $value )) ?>" target="_blank"><?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?></a>

                    </div>

                <?php endforeach; 


                ?>

            </div>

               <div class="mycred-ranks-display">

					<h4>Ranks</h4>

				</div>
					<div class="mycred-bbpress-profile-user-ranks-type">
        		 	  	  <span class="mycred-bbpress-profile-ranks-label mycred-bbpress-ranks-label">
                            <?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?>
                         </span>
                         <a href="<?php echo esc_url(get_permalink( $users_rank->post_id )) ?>" target="_blank"><?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?></a>
                    </div>

                    <?php

        }


        public function mycred_buddypress_get_member_avatar($avatar) {

        	global $post,$mycred_rank,$mycred,$activities_template, $members_template;

        	$mycred_types = mycred_get_types();
        	$output = '';
        	$settings = mycred_get_addon_settings( 'buddypress' );
        	$buddyboss_avatar_points = mycred_get_option( 'members_avatar_points', true );
        	
        	$ranks = array();

        	if( empty( $members_template->member->id ) ) {
        		return $avatar;
    		}


    		$user_id = $members_template->member->id;


        	$users_rank = mycred_get_users_rank( $user_id);
        	
        	if( class_exists( 'myCRED_Ranks_Module' ) ){
				$ranks = mycred_get_ranks();
			}

			if( class_exists( 'myCRED_Badge' ) ) {
				$badges = mycred_get_badge_ids();
			}
			$ids_title = array();
			$badges_data = array();

			
        	// Check for exclusion
			if ( $this->core->exclude_user( $user_id ) ) return;

        	$current_point_type = isset( $_GET['ctype'] ) ? sanitize_text_field( wp_unslash( $_GET['ctype'] ) ) : MYCRED_DEFAULT_TYPE_KEY;

        	if(!empty($buddyboss_avatar_points)) : ?>

        	<div class="mycred-buddypress-user-details mycred-buddypress-user-details-listing">

        	<?php echo $avatar; ?>
              <?php if(is_array($buddyboss_avatar_points) || is_object($buddyboss_avatar_points)) : ?>

        	<?php foreach( $buddyboss_avatar_points as $type => $label ) : ?>
	  	
 			  <?php
        		 	  	$mycred   = mycred( $type );

        		 	  	if ( $mycred->exclude_user( $user_id ) ) continue;

        		 	  	$balance  = $mycred->get_users_balance( $user_id, $type );

        		 	  	 	if($buddyboss_avatar_points[$type] == true) : ?>

        		 	  	<div class="mycred-bbpress-user-avatar-points-type">

	        		 	  	<span class="mycred-bbpress-points-avatar-label mycred-bbpress-label">
	                            <?php echo esc_html_e( $mycred->plural() . ': ', 'mycred_buddyboss' ); ?>
	                        </span>

	        		 	  	<span class="mycred-bbpress-points-avatar-type mycred-bbpress-points-type">
	                            <?php echo esc_html_e( $mycred->format_creds( $balance ), 'mycred_buddyboss' ); ?>
	                        </span>

                        </div>

                         <?php endif; ?>
                          
        		 	  	<?php endforeach; ?>
        		 	  	<?php endif; ?>
        		

                      <?php if(is_array($users_rank) || is_object($users_rank)) : ?>
        		      <?php

                        	foreach ($users_rank as $key => $value)  : ?>

                        	
					   <div class="mycred-bbpress-avatar-user-ranks-type">

        		 	  	  <span class="mycred-bbpress-avatar-ranks-label mycred-bbpress-ranks-label">
                            <?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?>
                         </span>

                         <a href="<?php echo esc_url(get_permalink( $users_rank->post_id )) ?>" target="_blank"><?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?></a>

                       </div>
                        <?php break; ?>
                        <?php endforeach; ?>
                         <?php endif; ?>


                         <?php

                        	foreach ($badges as $key => $value)  : ?>

                        	<?php

							$badges_data[$key]['id'] = $value;
                			$badges_data[$key]['title'] = get_the_title($value);
							?>

					   <div class="mycred-bbpress-avatar-user-badges-type">

        		 	  	 <span class="mycred-bbpress-avatar-badges-label mycred-bbpress-avatar-badges-label">
                            <?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?>
                         </span>

                         	<a href="<?php echo esc_url(get_permalink( $value )) ?>" target="_blank"><?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?></a>

                       </div>

                        <?php endforeach; 

			?>
            <?php endif;
                        ?>

			</div>

			<?php 

        }

        public function mycred_buddypress_profile_header($output) {


        	global $mycred_badge;
        	$user_id = bp_displayed_user_id();
        	$buddyboss_settings = mycred_get_addon_settings( 'buddyboss' );

        	if( class_exists( 'myCRED_Badge' ) ) {
				$badges = mycred_get_badge_ids();
			}

			if( class_exists( 'myCRED_Ranks_Module' ) ){
				$ranks = mycred_get_ranks();
			}

			$ids_title = array();
			$badges_data = array();
			$buddyboss_profile_points = mycred_get_option( 'buddyboss_profile_points', true );
			$user_id      = bp_displayed_user_id();
			$users_rank = mycred_get_users_rank( $user_id);


			if(!empty($buddyboss_profile_points)) : ?>

                <?php if(is_array($buddyboss_profile_points) || is_object($buddyboss_profile_points)) : ?>

				 <?php foreach( $buddyboss_profile_points as $type => $label ) : ?>

        		 	  	<?php 

        		 	  	$mycred   = mycred( $type );

        		 	  	if ( $mycred->exclude_user( $user_id ) ) continue;

        		 	  	$balance  = $mycred->get_users_balance( $user_id, $type );

						$settings = mycred_get_addon_settings( 'buddypress' );


        		 	  	if($buddyboss_profile_points[$type] == true) : ?>

        		 	  	<div class="mycred-bbpress-user-profile-points-type">

	        		 	  	<span class="mycred-bbpress-profile-points-label mycred-bbpress-profile--label">
	                            <?php echo esc_html_e( $mycred->plural(). ':' , 'mycred_buddyboss' ); ?>
	                        </span>

	        		 	  	<span class="mycred-bbpress-profile-points-type mycred-bbpress-profile-points-type">
	                            <?php echo esc_html_e( $mycred->format_creds( $balance ), 'mycred_buddyboss' ); ?>
	                        </span>

                        </div>


			 <?php endif; 
			       endforeach; 
			       endif;
			       endif;


       		if(is_array($badges) || is_object($badges)) : 
            foreach ($badges as $key => $value)  : ?>

                <?php

					$badges_data[$key]['id'] = $value;
                	$badges_data[$key]['title'] = get_the_title($value);


				?>

				   <div class="mycred-bbpress-profile-user-badges-type">

        		 	  	 <span class="mycred-bbpress-profile-badges-label mycred-bbpress-profile-badges-label">
                            <?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?>
                         </span>

                         	<span class="badge-text"><?php echo 'Badge: ' . ' ' ?></span><a href="<?php echo esc_url(get_permalink( $value )) ?>" target="_blank"><?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?></a>

                    </div>


                <?php endforeach; 
                	 endif;
               
				if(is_array($users_rank) || is_object($users_rank)) : 
                 foreach ($users_rank as $key => $value)  : ?>

					<div class="mycred-bbpress-profile-user-ranks-type">

        		 	  	  <span class="mycred-bbpress-profile-ranks-label mycred-bbpress-ranks-label">
                            <?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?>
                         </span>

                         <span class="rank-text"><?php echo 'Rank: '. ' ' ?></span><a href="<?php echo esc_url(get_permalink( $users_rank->post_id )) ?>" target="_blank"><?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?></a>

                       
                    </div>

                    <?php break;
                          endforeach; 
                           endif;



        }

        public function buddyboss_front_scripts() {

        	wp_enqueue_style( 
					'mycred_buddyboss_front_style', 
					plugin_dir_url( __DIR__ ) . 'assets/css/mycred-buddyboss-front.css', 
					'', 
					'1.0' 
				);

        }

        public function mycred_bbp_reply_author_details() {

        	$reply_id = bbp_get_reply_id();

        	// User is not a guest
		    if ( bbp_is_reply_anonymous( $reply_id ) )
		        return;

        	$user_id = bbp_get_reply_author_id( $reply_id );

		   
		    $this->mycred_bbp_author_details( $user_id );

        }


        public function mycred_bbp_author_details( $user_id) {
      
        	global $post,$mycred_rank,$mycred;
        	$mycred_types = mycred_get_types();
        
        	$output = '';
        	$settings = mycred_get_addon_settings( 'buddypress' );
        	$buddyboss_settings = mycred_get_addon_settings( 'bb_forums_cred' );
        	$buddyboss_forums_points = mycred_get_option( 'buddyboss_forums_points', true );
        	$users_rank = mycred_get_users_rank( get_current_user_id());

        	if( class_exists( 'myCRED_Ranks_Module' ) ){
				$ranks = mycred_get_ranks();
			}

			if( class_exists( 'myCRED_Badge' ) ) {
				$badges = mycred_get_badge_ids();
			}

			$ids_title = array();
			$badges_data = array();

        	// Check for exclusion
			if ( $this->core->exclude_user( $user_id ) ) return;

			$current_point_type = isset( $_GET['ctype'] ) ? sanitize_text_field( wp_unslash( $_GET['ctype'] ) ) : MYCRED_DEFAULT_TYPE_KEY;

        	if(!empty($buddyboss_forums_points)) : ?>

        		<div class="mycred-bbpress-user-points-type">

        			  <?php if(is_array($buddyboss_forums_points) || is_object($buddyboss_forums_points)) : ?>
        		 	  <?php foreach( $buddyboss_forums_points as $type => $label ) : ?>

        		 	  	<?php 

        		 	  	$mycred   = mycred( $type );

        		 	  	if ( $mycred->exclude_user( $user_id ) ) continue;

        		 	  	$balance  = $mycred->get_users_balance( $user_id, $type );
        		 	  	
        		 	  	if(!empty($buddyboss_settings['sort'][$type])) :

        		 	  	if($buddyboss_settings['sort'][$type] == true) : ?>

        		 	  	<div class="mycred-bbpress-points">

	        		 	  	<span class="mycred-bbpress-points-label mycred-bbpress-label">
	                            <?php echo esc_html_e( $label, 'mycred_buddyboss' ); ?>
	                        </span>

	        		 	  	<span class="mycred-bbpress-points-type mycred-bbpress-points-type">
	                            <?php echo esc_html_e( $balance ,'mycred_buddyboss' ); ?>
	                        </span>

                        </div>

                    <?php endif; ?>
                     <?php endif; ?>
        		 	  	<?php endforeach; ?>
        		 	  	<?php endif; ?>
        		</div>

        		      <?php

        		      	    if(is_array($users_rank) || is_object($users_rank)) :

                        	foreach ($users_rank as $key => $value)  : ?>

					   <div class="mycred-bbpress-user-ranks-type">

        		 	  	  <span class="mycred-bbpress-ranks-label mycred-bbpress-ranks-label">
                            <?php echo esc_html_e( $users_rank->title, 'mycred_buddyboss' ); ?>
                         </span>

                         <a href="<?php echo esc_url(get_permalink( $users_rank->post_id )) ?>" target="_blank"><?php echo esc_html_e($users_rank->title, 'mycred_buddyboss' ); ?></a>

                       </div>

                        <?php   break;
                                endforeach; 
                        		endif;
                        ?>


                         <?php

                         	 if(is_array($badges) || is_object($badges)) :
                        	foreach ($badges as $key => $value)  : ?>

                        	<?php


							$badges_data[$key]['id'] = $value;
                			$badges_data[$key]['title'] = get_the_title($value);

							?>

					   <div class="mycred-bbpress-user-badges-type">

        		 	  	 <span class="mycred-bbpress-badges-label mycred-bbpress-badges-label">
                            <?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?>
                         </span>

                         	<a href="<?php echo esc_url(get_permalink( $value )) ?>" target="_blank"><?php echo esc_html_e( $badges_data[$key]['title'], 'mycred_buddyboss' ); ?></a>

                       </div>

                        <?php endforeach; 
                        	  endif;
                        ?>
					
			<?php 

			?>

            <?php endif;

			$profile_header_output = apply_filters( 'mycred_bp_profile_header', $output, '', $this );

            echo esc_html($profile_header_output);

        }

        public function mycred_bp_activity_content($content,$activity) {


        	global $activities_template;

        	if( empty( $activity->user_id )) {

        		return $content;

        	}

    		$user_id = $activity->user_id;

        	   ob_start();

			if (is_numeric($user_id) && $user_id > 0) {
                 $this->mycred_bp_user_details_display( $user_id, 'activity' );
            }

			$details = ob_get_clean();

			return $details . $content;
 	
        }

        public function mycred_bp_activity_empty_content() {


        	if( bp_activity_has_content() ) {
		        return;
		    }


		    if( function_exists( 'bp_nouveau_activity_has_content' ) ) {
			        if( bp_nouveau_activity_has_content() ) {
			            return;
			        }
			}

			echo esc_html($this->mycred_bp_user_details_display( bp_get_activity_user_id(), 'activity' ));

        }

        public function mycred_bp_user_details_display( $user_id, $view ) {

        	global $mycred,$level_image;

        	if( absint( $user_id ) === 0 ) {
        		return;
    		}

    		if( class_exists( 'myCRED_Badge' ) ) {
				$all_badges = mycred_get_badge_ids();
			}
    		
    		$users_badges = mycred_get_users_badges( $user_id, true );
    		$earned       = array();
			$users_rank = mycred_get_users_rank( $user_id );
            $buddyboss_profile_points = mycred_get_option( 'buddyboss_profile_points', array() );

            if(!empty($buddyboss_profile_points)) {

            	if(is_array($buddyboss_profile_points) || is_object($buddyboss_profile_points)) {

            	foreach ($buddyboss_profile_points as $point_type => $point_type_label) {

	            	$myCred = mycred($point_type); 

	            	$balance  = $mycred->get_users_balance( $user_id, $point_type );

					if($buddyboss_profile_points[$point_type] == true) {

            	?>

            	<div class="mycred-bbpress-user-profile-points-type">

	            	<span class="mycred-bbpress-profile-points-label mycred-bbpress-profile--label">
		                            <?php echo esc_html_e( $point_type_label. ':' , 'mycred_buddyboss' ); ?>
		            </span>

		            <span class="mycred-bbpress-profile-points-type mycred-bbpress-profile-points-type">
		                            <?php echo esc_html_e( $mycred->format_creds( $balance ), 'mycred_buddyboss' ); ?>
		            </span>

	            </div>

	                       <?php

	         	}
            	
              }
          }

            }

                 if(is_array($all_badges) || is_object($all_badges)) {

            	 foreach ( $all_badges as $badge_id ) {


						 	 	 $badge_id     = absint( $badge_id );
                                 $has_earned   = mycred_get_badge( $badge_id );
                                 $badge        = mycred_get_badge( $badge_id );

                                  $users_badges = mycred_get_users_badges($user_id );
                                  $mycred = mycred();

                                  if ( array_key_exists( $badge_id, $users_badges ) ) {
                                        $earned       = 1;
                                        $earned_level = $users_badges[ $badge_id ];
                                        $badge_image  = $badge->get_image( $earned_level );

                                       
                                    }


                                  if($has_earned ) {

                                  	$badge_title = $has_earned->title;
	            					$badge_img = $has_earned->main_image;
	            					$level_image = $has_earned->level_image;
	            					$show_img = $has_earned->user_has_badge( $user_id );
	            				
	            					if($show_img) {

	            					echo '<div class="user-badges">';

	            					echo '<span class="user-badge-heading"><b>Badge: </b> </span>'  ;

	            					echo   '<span>' . esc_html_e($badge_title) . ' '.'</span>';
	            					echo '<span>' . $badge_image . '</span>';

	            					echo '</div>';

	            					}


                                  }
						
						}

					}


							if(class_exists( 'myCRED_Ranks_Module' )) {

								// Get rank object
								$rank = mycred_get_users_rank( $user_id );
								
								$account_object = mycred_get_account( $user_id );

								$ranks = mycred_get_ranks('publish', -1, 'DESC');

								if($users_rank) {
							

										echo '<div class="user-ranks">';

										echo '<span class="user-rank-heading"><b>Rank: </b> </span>'  ;
										echo '<span>' .esc_html_e($users_rank->title) . '</span>';


											echo '<span>' . esc_html_e($users_rank->get_image( 'logo' )) . '</span>';
			
										echo '</div>';
	

							}


						}


			$display_options = apply_filters( 'mycred_bp_user_details_display_options',  $user_id, $view );

		
        }


        public function mycred_bp_activity_allowed_tags($activity_allowed_tags) {

		    $activity_allowed_tags['div'] = array();
		    $activity_allowed_tags['div']['id'] = array();
		    $activity_allowed_tags['div']['class'] = array();


		    return $activity_allowed_tags;
        }

        public function mycred_bbp_sanitize_text_array( $items ) {

		    foreach( $items as $i => $item ) {
		        $items[$i] = sanitize_text_field( $item );
		    }

		    return $items;

		}

        public function sanitize_extra_settings( $new_data, $data, $core ) {

        	global $mycred_types;

			$point_types = mycred_get_types();
			$forums_settings = mycred_get_types();
			$activity_settings = mycred_get_types();
			$members_avatar_settings = mycred_get_types();
		
			$ranks_options = array();

			$badges_options = array();

			if( class_exists( 'myCRED_Badge' ) ) {
				$badge_ids = mycred_get_badge_ids();
			}

        
        	foreach( $badge_ids as $id ) {
            	$badges_options[$id] = get_the_title( $id );
            }
			


	         foreach( $mycred_types as $key => $value )
            {
                $_ranks = mycred_get_ranks( 'publish', '-1', 'ASC', $key );

                foreach( $_ranks as $key => $value )
                {
                    $ranks_options[$value->post->ID] = $value->post->post_title;
                }
            }



			if(isset($data['badges_options']['sort'])  && ! empty( $data['badges_options']['sort'] )) {

					foreach ( $data['badges_options']['sort'] as $key => $value ) {

						

					$badges_key = sanitize_key( $key );
					$badges_is_enabled = false;

					if( $value === 'true' ) {
						$badges_is_enabled = true;	
					}

					$badges_options[ $badges_key ] = $badges_is_enabled;	
	
				}

			}


			if(isset($data['ranks_options']['sort'])  && ! empty( $data['ranks_options']['sort'] )) {

				foreach ( $data['ranks_options']['sort'] as $key => $value ) {

					$ranks_key = sanitize_key( $key );
					$ranks_is_enabled = false;

					if( $value === 'true' ) {
						$ranks_is_enabled = true;	
					}

					$ranks_options[ $ranks_key ] = $ranks_is_enabled;	
	
				}

			}

			$new_data['buddyboss']['types']['sort'] = $point_types;
			$new_data['bb_forums_cred']['sort'] = $forums_settings;
			$new_data['activity']['sort'] = $activity_settings;
			$new_data['members_avatar']['sort'] = $members_avatar_settings;
			$new_data['ranks_options']['sort'] = $ranks_options;
			$new_data['badges_options']['sort'] = $badges_options;
		

			mycred_update_option( 'buddyboss_profile_points', $point_types );
			mycred_update_option( 'buddyboss_forums_points', $forums_settings );
			mycred_update_option( 'buddyboss_activity_points', $activity_settings );
			mycred_update_option( 'members_avatar_points', $members_avatar_settings );
			mycred_update_option( 'buddyboss_badges', $badges_options );
			mycred_update_option( 'buddyboss_ranks', $ranks_options );

        	return $new_data;

        }

        public function mycred_get_settings() {

			$mycred   = mycred();
			if ( $point_type != MYCRED_DEFAULT_TYPE_KEY )
				$mycred = mycred( $point_type );

				if ( isset( $mycred->buddypress ) ) {
					$settings = $mycred->buddypress;
				}
				else {
					global $mycred_modules;
					$settings = $mycred_modules['solo']['buddypress']->buddypress;
				}
			return $settings;
		}

        public function mycred_bp_set_member_type($user_id, $member_type, $append) {
        	return $member_type;
        }


        public function load_buddyboss_dependency_scripts() {

    		wp_enqueue_script('mycred-bp-blockusers-script', plugin_dir_url(__DIR__) . 'assets/js/block-users.js', array
    			('jquery', 'jquery-ui-sortable'),'0.3', true);

    		
    		wp_enqueue_script('mycred-selectize-script', plugin_dir_url(__DIR__) . 'assets/js/selectize.min.js', array('jquery'),'0.4', true);


    		wp_enqueue_style( 
					'mycred_buddyboss_admin_style', 
					plugin_dir_url( __DIR__ ) . 'assets/css/mycred-buddyboss-admin.css', 
					'', 
					'1.0' 
				);

    		wp_enqueue_style( 
					'mycred_buddyboss_selectize_style', 
					plugin_dir_url( __DIR__ ) . 'assets/css/selectize.default.css', 
					'', 
					'1.1' 
				);

        }
 

        public function mycred_get_points_types_slugs() {

        	global $mycred_types;

		    // Assume we have no registered points types
		    $points_type_slugs = array();

		    // If we do have any points types, loop through each and add their slug to our array
		    foreach ( $mycred_types as $slug => $data ) {
		        $points_type_slugs[] = $slug;
		    }

		    // Finally, return our data
		    return $points_type_slugs;

		}


		public function mycred_get_buddyboss_points_types() {

			global $bp, $mycred_types, $post, $mycred;

        	$point_types    = mycred_get_types(true);

		    // Assume we have no registered points types
		    $mycred_point_types = array();

		    // If we do have any points types, loop through each and add their slug to our array
		    foreach ( $point_types as $slug => $data ) {
		       $mycred_point_types[] = $data;
		    }

		    // Finally, return our data
		    return $mycred_point_types;

		}


        
        public function mycred_buddyboss_user_settings( $object ) {
        	global $bp, $mycred_types, $post, $mycred,$mycred_label;

        	$options = array();   	
			$buddypress = ( ( class_exists( 'BuddyPress' ) ) ? true : false );
			wp_enqueue_style( 'mycred-select2-style' );
        	wp_enqueue_script( 'mycred-select2-script' );
			wp_enqueue_style( 'mycred-admin' );
			wp_enqueue_style( 'mycred-bootstrap-grid' );
			wp_enqueue_style( 'mycred-forms' );
			$buddyboss_profile_points = mycred_get_option( 'buddyboss_profile_points', true );
			$buddyboss_forums_points = mycred_get_option( 'buddyboss_forums_points', true );
			$buddyboss_activity_points = mycred_get_option( 'buddyboss_activity_points', true );
			$buddyboss_avatar_points = mycred_get_option( 'members_avatar_points', true );
			$badges_options_settings = mycred_get_option( 'buddyboss_badges', true );
			$badges_user_settings = array();
			$users_rank = mycred_get_users_rank( get_current_user_id());

			if (is_array($badges_options_settings) || is_object($badges_options_settings))  {
				foreach ($badges_options_settings as $key =>  $value) {
					$badges_user_settings[$key] = $value;

				}
		    }

			$ranks_options_settings = mycred_get_option( 'buddyboss_ranks', true );
			$ranks_user_settings = array();

	      
			if (is_array($ranks_options_settings) || is_object($ranks_options_settings))  {
			    foreach( $ranks_options_settings as $key => $value ) {
		               $ranks_user_settings[$key] = $value;
	  
		        }
		    }

            if( ! function_exists( 'bp_get_member_types' ) ) {
        		return $options;
             }

          
        	 $member_types = bp_get_member_types( array(), 'objects' );
        	  foreach( $member_types as $member_type => $member_type_obj ) {
                  $options[$member_type] = $member_type_obj->labels['singular_name'];
               }


                $excluded_ids = explode( ',', esc_attr( $this->core->exclude['by_roles'] ) );
               	$options_args = array(
				'name'		=>	$this->field_name( array( 'exclude' => 'by_roles' ) ) . '[]',
				'id'		=>	$this->field_id( array( 'exclude' => 'by_roles' ) ),
				'class'		=>	'bulk-users',
				'single'	=>	'single'
				);

               	
               	
            if ( ! defined( 'BP_PLATFORM_VERSION' ) ) {
            	return false;
            }
   
			if ( class_exists( 'BuddyPress' )  && function_exists( 'buddypress' ) && buddypress() && is_plugin_active('mycred-buddyboss/mycred-buddyboss.php') ):

				$point_types    = mycred_get_types(true);
				$forums_point_types    = mycred_get_types(true);
				$activity_point_types    = mycred_get_types(true);
				$avatar_point_types    = mycred_get_types(true);
				$has_rank = mycred_get_my_rank('mycred_default');
				$users_rank = mycred_get_users_rank( get_current_user_id(), 'mycred_default' );

				
				
			   		 ?>

            <div class="mycred-buddyboss-settings">
            	<div class="row">
            		<div class="col-lg-3 col-md-3 col-sm-12 col-xs-12">
			            <div class ="form-group" >
			            	<label for="<?php echo esc_attr($options_args['id']); ?>"><?php esc_html_e( 'Blocked Profile Types', 'mycred' ); ?></label>

			            	 <?php echo wp_kses(
                                    mycred_create_select2( $options, $options_args, $excluded_ids ),
                                    array(
                                        'select' => array(
                                            'id' => array(),
                                            'class' => array(),
                                            'name' => array(),
                                            'style' => array()
                                        ),
                                        'option' => array(
                                            'value' => array(),
                                            'selected' => array()
                                        ),
                                    )
                                 ); 

								?>   
			            </div>
			        </div>
	            </div>
	        <div class="row">
				<div class="col-lg-3 col-md-3 col-sm-12 col-xs-12">

					<h3 class="buddyboss-profile-points"><?php esc_html_e( 'BuddyBoss Profile', 'mycred_buddyboss' ); ?></h3>

					  <div class="user-profile">

					 	<h3 class="buddyboss-profile"><?php esc_html_e( 'BuddyBoss Point Types', 'mycred_buddyboss' ); ?></h3>

					 	<select name="mycred_pref_core[buddyboss][types]"  id="user-profile-id" multiple="multiple" class="buddyboss-all-profile">

					 		<?php 

					 	if(!empty($buddyboss_profile_points)) {
					 
                    	if (is_array($buddyboss_profile_points) || is_object($buddyboss_profile_points)) {
                            foreach ( $buddyboss_profile_points as $type_id => $type_label ) {

                            	$selected = "";
					    		if ( $buddyboss_profile_points[$type_id] == true ) {
					    			$selected = "selected";
					    		}

                                echo '<option name="" value="'.esc_attr($type_id).'" ' . esc_attr($selected) . '>'. esc_html($type_label) .'</option>';

                             }
                          
                        }

                    }


					 		?>
					 		

					 	</select>
					 	
					 </div>

					
					 <div class="user-badges">

					 	<h3 class="buddyboss-badges"><?php esc_html_e( 'BuddyBoss Point Type Badges', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-badges" id="user-badges-id" multiple="multiple" class="buddyboss-all-badges">

					 		<?php 
 	

                    	if( !empty( $badges_user_settings ) ) {
                            foreach ( $badges_user_settings as $key => $value ):
                                if( empty( $value ) ) {
                                    continue;
                                }

                                

                                $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}
                                echo '<option value="'.esc_attr($key).'" ' . esc_attr($selected) . '>'. esc_html($value) .'</option>';
                            endforeach;
                        }


					 		?>
					 		

					 	</select>
					 	
					 </div>

				
					 <div class="user-ranks">

					 	<h3 class="buddyboss-ranks"><?php esc_html_e( 'BuddyBoss Point Type Ranks', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-ranks" id="user-ranks-id" multiple="multiple" class="buddyboss-all-ranks">

					 		<?php 

	                foreach( $users_rank as $key => $value )
	                {

	                		 $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}

	                      echo '<option value="'.esc_attr($users_rank->post_id).'" ' . esc_attr($selected) . '>'. esc_html($users_rank->title) .'</option>';
	                }

					 		?>
					 		

					 	</select>
					 	
					 </div>
           			 
				</div>

				<!-- BuddyBoss Forums Starts -->

				<div class="col-lg-3 col-md-3 col-sm-12 col-xs-12">

					<h3 class="buddyboss-forum-points"><?php esc_html_e( 'BuddyBoss Forums', 'mycred_buddyboss' ); ?></h3>

					  <div class="user-forum">

					 	<h3 class="buddyboss-forum"><?php esc_html_e( 'BuddyBoss Forum Point Types', 'mycred_buddyboss' ); ?></h3>

					 	<select name="mycred_pref_core[bb_forums_cred][sort]"  id="user-forum-id" multiple="multiple" class="buddyboss-all-forum">

					 		<?php 

					 
                    	if( !empty( $forums_point_types ) ) {
                    		if (is_array($forums_point_types) || is_object($buddyboss_profile_points)) {
                            foreach ( $forums_point_types as $type_id => $type_label ) {

                            	$selected = "";
					    		if ( $forums_point_types[$type_id] == true ) {
					    			$selected = "selected";
					    		}

                                echo '<option name="" value="'.esc_attr($type_id).'" ' . esc_attr($selected) . '>'. esc_html($type_label) .'</option>';


                             }

                         }
                          
                        }

					 		?>

					 	</select>
					 	
					 </div>

					
					 <div class="user-forum-badges">

					 	<h3 class="buddyboss-forum-badges"><?php esc_html_e( 'BuddyBoss Forum Badges', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-forum-badges" id="user-forum-badges-id" multiple="multiple" class="buddyboss-all-forum-badges">

					 		<?php 
 	

                    	if( !empty( $badges_user_settings ) ) {
                            foreach ( $badges_user_settings as $key => $value ):
                                if( empty( $value ) ) {
                                    continue;
                                }

                                

                                $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}
                                echo '<option value="'.esc_attr($key).'" ' . esc_attr($selected) . '>'. esc_html($value) .'</option>';
                            endforeach;
                        }


					 		?>
					 		
					 	</select>
					 	
					 </div>
				
					 <div class="user-forum-ranks">

					 	<h3 class="buddyboss-forum-ranks"><?php esc_html_e( 'BuddyBoss  Forum Ranks', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-forum-ranks" id="user-forum-ranks-id" multiple="multiple" class="buddyboss-all-ranks">

					 		<?php 
	             
	                foreach( $users_rank as $key => $value )
	                {

	                		 $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}

	                      echo '<option value="'.esc_attr($users_rank->post_id).'" ' . esc_attr($selected) . '>'. esc_html($users_rank->title) .'</option>';
	                }

					 		?>
					 		

					 	</select>
					 	
					 </div>
           			 
				</div>

				<!-- BuddyBoss Forums Ends -->

				<!-- BuddyBoss Activity Starts -->

					<div class="col-lg-3 col-md-3 col-sm-12 col-xs-12">

					<h3 class="buddyboss-activity-points"><?php esc_html_e( 'BuddyBoss Activity', 'mycred_buddyboss' ); ?></h3>

					  <div class="user-activity">

					 	<h3 class="buddyboss-activity"><?php esc_html_e( 'BuddyBoss Activity Point Types', 'mycred_buddyboss' ); ?></h3>

					 	<select name="mycred_pref_core[activity][sort]"  id="user-activity-id" multiple="multiple" class="buddyboss-all-activity">

					 		<?php 

                    	if (is_array($buddyboss_activity_points) || is_object($buddyboss_activity_points)) {
                            foreach ( $buddyboss_activity_points as $type_id => $type_label ) {



                            	$selected = "";
					    		if ( $buddyboss_activity_points[$type_id] == true ) {
					    			$selected = "selected";
					    		}

                            
                                echo '<option name="" value="'.esc_attr($type_id).'" ' . esc_attr($selected) . '>'. esc_html($type_label) .'</option>';


                             }
                          
                        }

					 		?>
					 		
					 	</select>
					 	
					 </div>

					
					 <div class="user-activity-badges">

					 	<h3 class="buddyboss-activity-badges"><?php esc_html_e( 'BuddyBoss Activity Badges', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-activity-badges" id="user-activity-badges-id" multiple="multiple" class="buddyboss-all-activity-badges">

					 		<?php 
 	
                    	if( !empty( $badges_user_settings ) ) {
                            foreach ( $badges_user_settings as $key => $value ):
                                if( empty( $value ) ) {
                                    continue;
                                }

                                

                                $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}
                                echo '<option value="'.esc_attr($key).'" ' . esc_attr($selected) . '>'. esc_html($value) .'</option>';
                            endforeach;
                        }

					 		?>

					 	</select>
					 </div>
					 <div class="user-activity-ranks">

					 	<h3 class="buddyboss-activity-ranks"><?php esc_html_e( 'BuddyBoss Activity Ranks', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-activity-ranks" id="user-activity-ranks-id" multiple="multiple" class="buddyboss-all-ranks">

					 		<?php 
	             
	                foreach( $users_rank as $key => $value )
	                {

	                		 $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}

	                      echo '<option value="'.esc_attr($users_rank->post_id).'" ' . esc_attr($selected) . '>'. esc_html($users_rank->title) .'</option>';
	                }
	            

					 		?>
					 		

					 	</select>
					 	
					 </div>
           			 
				</div>

				<!-- BuddyBoss Activity Ends -->

				<!-- BuddyBoss Members Avatar Starts -->

				<div class="col-lg-3 col-md-3 col-sm-12 col-xs-12">

					<h3 class="buddyboss-avatar-points"><?php esc_html_e( 'BuddyBoss Avatar', 'mycred_buddyboss' ); ?></h3>

	        	
					  <div class="user-avatar">

					 	<h3 class="buddyboss-avatar"><?php esc_html_e( 'BuddyBoss Avatar Point Types', 'mycred_buddyboss' ); ?></h3>

					 	<select name="mycred_pref_core[members_avatar][sort]"  id="user-avatar-id" multiple="multiple" class="buddyboss-all-avatar">

					 		<?php 
					 
                    	if (is_array($buddyboss_activity_points) || is_object($buddyboss_activity_points)) {
                            foreach ( $buddyboss_activity_points as $type_id => $type_label ) {

                            	$selected = "";
					    		if ( $buddyboss_activity_points[$type_id] == true ) {
					    			$selected = "selected";
					    		}

                            
                                echo '<option name="" value="'.esc_attr($type_id).'" ' . esc_attr($selected) . '>'. esc_html($type_label) .'</option>';


                             }
                          
                        }

					 		?>
					 		

					 	</select>
					 	
					 </div>
					
					 <div class="user-avatar-badges">

					 	<h3 class="buddyboss-avatar-badges"><?php esc_html_e( 'BuddyBoss Avatar Badges', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-avatar-badges" id="user-avatar-badges-id" multiple="multiple" class="buddyboss-all-avatar-badges">

					 		<?php 
 	
                    	if( !empty( $badges_user_settings ) ) {
                            foreach ( $badges_user_settings as $key => $value ):
                                if( empty( $value ) ) {
                                    continue;
                                }

                                

                                $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}
                                echo '<option value="'.esc_attr($key).'" ' . esc_attr($selected) . '>'. esc_html($value) .'</option>';
                            endforeach;
                        }


					 		?>
					 		

					 	</select>
					 	
					 </div>
				
					 <div class="user-avatar-ranks">

					 	<h3 class="buddyboss-avatar-ranks"><?php esc_html_e( 'BuddyBoss Avatar Ranks', 'mycred_buddyboss' ); ?></h3>

					 	<select name="buddyboss-user-avatar-ranks" id="user-avatar-ranks-id" multiple="multiple" class="buddyboss-all-avatar-ranks">

					 		<?php 
	             
	                foreach( $users_rank as $key => $value )
	                {

	                		 $selected = "";
					    		if ( isset($key) ) {
					    			$selected = "selected";
					    		}

	                      echo '<option value="'.esc_attr($users_rank->post_id).'" ' . esc_attr($selected) . '>'. esc_html($users_rank->title) .'</option>';
	                }

					 		?>	

					 	</select> 	
					 </div> 
				</div>
				<!-- BuddyBoss Members Avatar Ends -->
			 </div>	  
		   </div>
        
		<?php

	endif;

        }
   		 
	}
		function myCRED_buddy_blockusers_Settings() {

			return myCRED_buddy_blockusers_Settings::instance();
		
		}

		myCRED_buddy_blockusers_Settings();